fix converted table and field name collisions

03/05/2013 02:02 PM - Constantin Asofiei

Status: Closed Start date: 03/05/2013

Priority: Normal Due date:  

Assignee: Constantin Asofiei % Done: 100%

Category:  Estimated time: 0.00 hour

Target version: Conversion Support for Server Features   

billable: No case_num:  

vendor_id: GCD   

Description

History

#1 - 03/05/2013 02:05 PM - Constantin Asofiei

In 4GL, it is possible to have two tables names named p2j_test and p2j-test. Also, these field names can be in the same table: f_1 and f-1. Currently,

P2J doesn't solve such collisions, as both tables will be named P2jTest (from which only one will survive), and both fields will be named f1, thus

having compile-time errors as accessors with the same name will be generated for each one.

def temp-table tt1 field f_1 as int field f-1 as int.

#2 - 03/05/2013 02:39 PM - Constantin Asofiei

- File ca_upd20130305e.zip added

This update solves collisions for dmo, table, property and column names. It adds a numeric suffix, similar to how temp tables get it.

#3 - 03/05/2013 04:18 PM - Constantin Asofiei

I'm putting this through conversion regression testing.

#4 - 03/05/2013 05:16 PM - Constantin Asofiei

Passed conversion regression testing.

#5 - 03/05/2013 06:20 PM - Greg Shah

It looks fine.  Check it in and distribute it.

#6 - 03/06/2013 01:50 AM - Constantin Asofiei

- % Done changed from 0 to 100

Committed to bzr revision 10246.

#7 - 03/06/2013 07:26 AM - Ovidiu Maxiniuc

By chance I prepared a sample test-case for this issue which at this moment is not converted correctly by p2j:
def temp-table tt1 field f11 as date field f1 as logical field f-1 as int field f_1 as char.

find first tt1.

display f11 + 2 f1 f-1 + 2 f_1 + "2".

#8 - 03/06/2013 07:38 AM - Constantin Asofiei

Ovidiu, sorry I hijacked this from you last night. Anyway, this case I don't think is encountered in the server project, and if this is confirmed, we can

leave it as a fix for later (p2o.xml just needs to use a loop in each place where the suffix is computed).

#9 - 03/06/2013 09:00 AM - Greg Shah

If this is easy enough to fix, please go ahead and put the fix in.  That way we don't have to remember there is a problem here.

#10 - 03/06/2013 09:12 AM - Constantin Asofiei

Yes, the fix is pretty simple. I'll provide an update today.

#11 - 03/06/2013 10:46 AM - Constantin Asofiei

- File ca_upd20130306e.zip added

This solves the collision cases for good. Also, I've added support for buffer names collision check. I'm putting this through conversion regression

testing.

#12 - 03/06/2013 11:40 AM - Constantin Asofiei

Update has passed conversion regression testing - no changes in generated code.

#13 - 03/06/2013 11:54 AM - Greg Shah

Check it in and distribute it.

#14 - 03/06/2013 12:42 PM - Constantin Asofiei

Committed to bzr revision 10257.

#15 - 03/17/2013 03:42 PM - Eric Faulhaber

- Status changed from WIP to Closed

#16 - 11/16/2016 11:06 AM - Greg Shah

- Target version changed from Milestone 4 to Conversion Support for Server Features

Files

ca_upd20130305e.zip 14.3 KB 03/05/2013 Constantin Asofiei

ca_upd20130306e.zip 14.4 KB 03/06/2013 Constantin Asofiei
